## This R script program is for calculating phosphorylation site quantitation mentioned in the paper A data-independent acquisition-based global phosphoproteomics system enables deep profiling by Kitata et al.
## This program is customized for phosphosites abundances of DIA data generated based on Spectranauts results.


library(data.table)

# InputFile (InputFormat, please check "1_20201023_Phospho-directDIA-PC9-Precursor-p99(ManuallyExtractFromSpectronautOutput).txt") 
# The first 5 columns must be"PG.ProteinAccessions", "PG.Genes", "PG.ProteinDescriptions", "PEP.StrippedSequence", "EG.ProteinPTMLocations", then following columns are peptide abundance values.
 
INname<-list.files(pattern=".txt") 

#OutputFileName
FFilime<-paste("FF_QuanSite_",list.files(pattern=".txt"),sep="") 

FFkey<-1
while(FFkey<=length(FFilime)) 
{
Da1<-as.matrix(fread(INname[FFkey],sep="\t",header=T))
k<-1
Teem<-NULL
while(k<=length(Da1[,1]))
{
    Sites<-unlist(strsplit( gsub(")","", gsub("(","",unlist(strsplit( as.matrix(Da1[k,5]),";"))[1],fixed=T),fixed=T) ,","))
      protin<-as.matrix(Da1[k,1])
     quanti<-as.matrix(Da1[k,6:length(Da1[1,])])     
   z<-1
   while(z<=length(Sites))
   {
     if(grepl("S",Sites[z]) || grepl("T",Sites[z]) ||grepl("Y",Sites[z]))
     {
     Teem<-rbind(Teem,c(paste(protin,"_",Sites[z],".",sep=""), quanti))
      }
    z<-z+1
   }
k<-k+1
}

Uni_Site<-unique(Teem[,1])

u<-1
TTTTnn<-NULL
while(u<=length(Uni_Site))  
{
  SSnum<-grep(Uni_Site[u],Teem[,1],fixed=T)
   AS_now<-as.matrix(Teem[SSnum,])   
      if(length(SSnum)==1)
      {
              TTTTnn<-rbind(TTTTnn,  c( AS_now[1],   as.numeric(AS_now[2:length( AS_now)])))
      }else{
                  xxTT<-NULL
                  p=2
                  while(p <= length( AS_now[1,]) )    #row n+1
                  {
                      xxTT<- cbind( xxTT,sum(as.numeric(AS_now[,p])) )
                      p<-p+1
                  }
              TTTTnn<-rbind(TTTTnn,  c( AS_now[1,1],  xxTT))
            }

u<-u+1
}

 COLNAME<-as.matrix(c("pSite",colnames(Da1)[ 6:length(Da1[1,])]))
 colnames(TTTTnn)<- COLNAME
write.table(TTTTnn,FFilime[FFkey],sep="\t",col.names=T,row.names=F,quote=F,append=F)

FFkey<-FFkey+1
}



##########











